#include <stdio.h>

#define SHRINK (1.2f)
#define LEVELS (12)
#define MODEL "teapot.pfb"

void doNode(char *root, float x, float y, float z, int depth) {
  char name[2048] ;

  printf("under %s\n",root) ;
  sprintf(name, "%f,%f,%f", x, y, z) ;
  printf("scs %s %f %f %f 0 0 0 %f\n", name, x, y, z, 1.f/SHRINK) ;
  printf("file "MODEL"\n") ;
  
  if (depth>0)
    doNode(name, x*SHRINK, y*SHRINK, z*SHRINK, depth-1) ;

}

int main (int argc, char **argv) {
  printf("group root\n") ;
  printf("file "MODEL"\n") ;

  float x, y, z ;
  x = y = z = SHRINK ;
  int depth = LEVELS ;

  doNode("root",  x,  y,  z, depth) ;
  doNode("root",  x,  y, -z, depth) ;
  doNode("root",  x, -y,  z, depth) ;
  doNode("root",  x, -y, -z, depth) ;
  doNode("root", -x,  y,  z, depth) ;
  doNode("root", -x,  y, -z, depth) ;
  doNode("root", -x, -y,  z, depth) ;
  doNode("root", -x, -y, -z, depth) ;

  doNode("root",  x,  y, 0.f, depth) ;
  doNode("root",  x, 0.f,  z, depth) ;
  doNode("root",  x, 0.f, 0.f, depth) ;
  doNode("root", 0.f,  y,  z, depth) ;
  doNode("root", 0.f,  y, 0.f, depth) ;
  doNode("root", 0.f, 0.f,  z, depth) ;

  doNode("root", -x, -y, 0.f, depth) ;
  doNode("root", -x, 0.f, -z, depth) ;
  doNode("root", -x, 0.f, 0.f, depth) ;
  doNode("root", 0.f, -y, -z, depth) ;
  doNode("root", 0.f, -y, 0.f, depth) ;
  doNode("root", 0.f, 0.f, -z, depth) ;

}
